clear all

% Lectura de los videos de entrada
high=144;
width=176;
nameVideo='suzie@150@176x144.yuv';
numFramesLeidas=5;

numRefFrame=1;
numCurrentFrame=2;

% Se lee los ficheros de video
[Yvid, Uvid, Vvid]=leerVideoYUV_420(nameVideo, high, width, numFramesLeidas);

% Tamano del MB
mbSize = 16;
% Search area
p = 8;

numeroVectoresX=width/16;
numeroVectoresY=high/16;


% Exhaustive Search
[motionVect, computations] = motionEstES(squeeze(Yvid(:,:,numCurrentFrame)),squeeze(Yvid(:,:,numRefFrame)),mbSize,p);
imgComp = motionComp(squeeze(Yvid(:,:,numRefFrame)), motionVect, mbSize);
ESpsnr = imgPSNR( squeeze(Yvid(:,:,numCurrentFrame)), imgComp, 255);

% Visualizar datos
fprintf(1,'\n\n >>>>>>>>>>>>>>>>>>>>>> Exhaustive Search');
for lazoY=1:numeroVectoresY
    fprintf(1,'\n');
    for lazoX=1:numeroVectoresX
        fprintf(1,'(%2d,%2d)',motionVect(1,lazoX+(lazoY-1)*numeroVectoresX),...
            motionVect(2,lazoX+(lazoY-1)*numeroVectoresX) );
    end
end
fprintf(1,'\n\n PSNR: %f',ESpsnr);
fprintf(1,'\n Coste computacional: %f',computations);

% Three Step Search
[motionVect,computations ] = motionEstTSS(squeeze(Yvid(:,:,numCurrentFrame)),squeeze(Yvid(:,:,numRefFrame)),mbSize,p);
imgComp = motionComp(squeeze(Yvid(:,:,numRefFrame)), motionVect, mbSize);
TSSpsnr = imgPSNR(squeeze(Yvid(:,:,numCurrentFrame)), imgComp, 255);

% Visualizar datos
fprintf(1,'\n\n >>>>>>>>>>>>>>>>>>>>>> Three Step Search');
for lazoY=1:numeroVectoresY
    fprintf(1,'\n');
    for lazoX=1:numeroVectoresX
        fprintf(1,'(%2d,%2d)',motionVect(1,lazoX+(lazoY-1)*numeroVectoresX),...
            motionVect(2,lazoX+(lazoY-1)*numeroVectoresX) );
    end
end
fprintf(1,'\n\n PSNR: %f',TSSpsnr);
fprintf(1,'\n Coste computacional: %f',computations);

% Four Step Search
[motionVect, computations] = motionEst4SS(squeeze(Yvid(:,:,numCurrentFrame)),squeeze(Yvid(:,:,numRefFrame)),mbSize,p);
imgComp = motionComp(squeeze(Yvid(:,:,numRefFrame)), motionVect, mbSize);
SS4psnr = imgPSNR(squeeze(Yvid(:,:,numCurrentFrame)), imgComp, 255);
SS4computations = computations;

% Visualizar datos
fprintf(1,'\n\n >>>>>>>>>>>>>>>>>>>>>> Four Step Search');
for lazoY=1:numeroVectoresY
    fprintf(1,'\n');
    for lazoX=1:numeroVectoresX
        fprintf(1,'(%2d,%2d)',motionVect(1,lazoX+(lazoY-1)*numeroVectoresX),...
            motionVect(2,lazoX+(lazoY-1)*numeroVectoresX) );
    end
end
fprintf(1,'\n\n PSNR: %f',SS4psnr);
fprintf(1,'\n Coste computacional: %f',SS4computations);

% Diamond Search
[motionVect, computations] = motionEstDS(squeeze(Yvid(:,:,numCurrentFrame)),squeeze(Yvid(:,:,numRefFrame)),mbSize,p);
imgComp = motionComp(squeeze(Yvid(:,:,numRefFrame)), motionVect, mbSize);
DSpsnr = imgPSNR(squeeze(Yvid(:,:,numCurrentFrame)), imgComp, 255);
DScomputations = computations;

% Visualizar datos
fprintf(1,'\n\n >>>>>>>>>>>>>>>>>>>>>> Diamond Search');
for lazoY=1:numeroVectoresY
    fprintf(1,'\n');
    for lazoX=1:numeroVectoresX
        fprintf(1,'(%2d,%2d)',motionVect(1,lazoX+(lazoY-1)*numeroVectoresX),...
            motionVect(2,lazoX+(lazoY-1)*numeroVectoresX) );
    end
end
fprintf(1,'\n\n PSNR: %f',DSpsnr);
fprintf(1,'\n Coste computacional: %f',DScomputations);

% Adaptive Rood Patern Search
[motionVect, computations] = motionEstARPS(squeeze(Yvid(:,:,numCurrentFrame)),squeeze(Yvid(:,:,numRefFrame)),mbSize,p);
imgComp = motionComp(squeeze(Yvid(:,:,numRefFrame)), motionVect, mbSize);
ARPSpsnr = imgPSNR(squeeze(Yvid(:,:,numCurrentFrame)), imgComp, 255);
ARPScomputations = computations;

% Visualizar datos
fprintf(1,'\n\n >>>>>>>>>>>>>>>>>>>>>> Adaptive Rood Patern Search');
for lazoY=1:numeroVectoresY
    fprintf(1,'\n');
    for lazoX=1:numeroVectoresX
        fprintf(1,'(%2d,%2d)',motionVect(1,lazoX+(lazoY-1)*numeroVectoresX),...
            motionVect(2,lazoX+(lazoY-1)*numeroVectoresX) );
    end
end
fprintf(1,'\n\n PSNR: %f',ARPSpsnr);
fprintf(1,'\n Coste computacional: %f',ARPScomputations);

%
fprintf(1,'\n');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo                                      %%
%% ruizrg@unican.es                                             %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%