%% Ejemplo 3. Ejemplo clculo de SAD (bloque 16x16) de una imagen entera  

close all

high=288;
width=352;
numTotalFrames=3;
nameVideo='Vectra@21@352x288.yuv';
numFrame=1;
sizeBlock=16; % Tamao 16x16

% Se lee el fichero de video
[YluOrig, UcrOrig, VcrOrig]=leerVideoYUV_420(nameVideo, high, width, numTotalFrames);

posX=140;
posY=180;
% Se selecciona la LUMA de la imagen numFrame
IR=squeeze( YluOrig(:,:,numFrame) );
% Se selecciona la LUMA de un bloque 16x16 de la imagen numFrame+1
IC=squeeze( YluOrig(posX:posX+sizeBlock-1,posY:posY+sizeBlock-1,numFrame+1) );

% Se calcula y muestra el valor del SAD
for fil=1:high-sizeBlock
    for col=1:width-sizeBlock
        SADfull(fil,col)=costFuncSAD(IR(fil:fil+sizeBlock-1,col:col+sizeBlock-1),IC);
    end
end

% Visualizacin 3D del SAD
mesh(double(SADfull));

% Calculo del valor minimo
[x,y]=find(SADfull == min(SADfull(:)));
fprintf(1,'\n\n Valor minimo SAD: %d, Coordenadas (%d, %d)\n',SADfull(x,y),x,y);


figure,
subplot(1,2,1), imshow(IR), title('IMAGEN VIDEO 1');
subplot(1,2,2), imshow(IC), title('IMAGEN VIDEO 2: bloque 16x16');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo                                      %%
%% ruizrg@unican.es                                             %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%