%% Ejemplo 2. Calculo del SAD para la estimacin de movimiento

clear all

high=288;
width=352;
numTotalFrames=3;
nameVideo='Vectra@21@352x288.yuv';
numFrame=1;

% Se lee el fichero de video
[YluOrig, UcrOrig, VcrOrig]=leerVideoYUV_420(nameVideo, high, width, numTotalFrames);

posX=140;
posY=180;
extArea=8;

% Se selecciona la LUMA 2*search+4x2*search+4 de la imagen numFrame
IR=squeeze( YluOrig(posX-extArea:posX+2*extArea+3,posY-extArea:posY+2*extArea+3,numFrame) );

fprintf(1,'\n ************** IR **************\n');
disp(IR);

% Se selecciona la LUMA de bloqu 4x4 de la imagen numFrame+1
IC=squeeze( YluOrig(posX:posX+3,posY:posY+3,numFrame+1) );
fprintf(1,'\n ************** IC **************\n');
disp(IC);

% Se calcula y muestra el valor del SAD
for x=0:2*extArea
    for y=0:2*extArea
        SAD(x+1,y+1)=costFuncSAD(IR(1+x:4+x,1+y:4+y),IC);
    end
end
SADp(1,1)=0;
SADp(2:2*extArea+2,1)=-extArea:extArea;
SADp(1,2:2*extArea+2)=-extArea:extArea;
SADp(2:2*extArea+2,2:2*extArea+2)=SAD;

fprintf(1,'\n ************** SAD **************\n');
disp(SADp);
fprintf('\n');

% Calculo del valor minimo
[x,y]=find(SAD == min(SAD(:)));
fprintf(1,'\n\n Valor minimo SAD: %d, Coordenadas (%d, %d)\n',SAD(x,y),x-extArea-1,y-extArea-1);

figure,
subplot(1,2,1), imshow(IR), title(['IMAGEN VIDEO 1:' sprintf(' %dx%d', 2*extArea+4,2*extArea+4)]);
subplot(1,2,2), imshow(IC), title('IMAGEN VIDEO 2: 4x4');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo y Juan A. Michell                    %%
%% ruizrg@unican.es, michellj@unican.es                         %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%