function cost = costFuncSAD(IA, IB)
%
% Calcula el MAD de dos imagenes
% Entradas:
%        IA: imagen 1
%        IB: imagen 2
%
% Ambas imagenes deben tener la misma dimension
%
% Salidas:
%    cost-> valor del coste SAD
%

[Mblk Nblk]=size(IA);
[Mref Nref]=size(IB);

if ( (Mblk ~= Mref) || (Nblk ~= Nref) )
    fprintf(1,'\n DIM current block (%d x %d) no coincide con el de ref block (%d x %d).\n',Mblk, Nblk, Mref, Nref);
    return;
end

% Se calcula el valor absoluto de la diferencia
Iabs= abs(( int32(IA) - int32( IB) ) );

cost = sum(sum(Iabs));



