% Computes motion compensated image's PSNR
%
% Input
%   imgP : The original image 
%   imgComp : The compensated image
%   n : the peak value possible of any pixel in the images
%
% Ouput
%   psnr : The motion compensated image's PSNR
%
% Written by Aroh Barjatya

function psnr = imgPSNR(imgP, imgComp, n)

[row col] = size(imgP);

err = 0;
A=double(imgP);
B=double(imgComp);

for i = 1:row
    for j = 1:col
        err = err + (A(i,j) - B(i,j))^2;
    end
end
mse = double(err )/ (row*col);

psnr = 10*log10(double(n*n)/mse);